/************************************************************************************/
/*  Program name CAPGLEXT_JE_LINES.sql                                              */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 9 JAN, 2005   NIP Karen         First created                                    */
/************************************************************************************/
SET VERIFY OFF
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_JE_LINES';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_JE_LINES.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		GJL.*
	FROM   
		GL_JE_LINES			GJL,
		GL_SETS_OF_BOOKS	SOB
	WHERE	GJL.SET_OF_BOOKS_ID			=	SOB.SET_OF_BOOKS_ID
	AND		SUBSTR(SOB.SHORT_NAME,5,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.JE_HEADER_ID||CHR(9)||
				C1.JE_LINE_NUM||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
					C1.SET_OF_BOOKS_ID||CHR(9)||
					C1.CODE_COMBINATION_ID||CHR(9)||
				C1.PERIOD_NAME||CHR(9)||
				C1.EFFECTIVE_DATE||CHR(9)||
				C1.STATUS||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
				C1.ENTERED_DR||CHR(9)||
				C1.ENTERED_CR||CHR(9)||
				C1.ACCOUNTED_DR||CHR(9)||
				C1.ACCOUNTED_CR||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
				C1.LINE_TYPE_CODE||CHR(9)||
				C1.REFERENCE_1||CHR(9)||
				C1.REFERENCE_2||CHR(9)||
				C1.REFERENCE_3||CHR(9)||
				C1.REFERENCE_4||CHR(9)||
				C1.REFERENCE_5||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.ATTRIBUTE11||CHR(9)||
				C1.ATTRIBUTE12||CHR(9)||
				C1.ATTRIBUTE13||CHR(9)||
				C1.ATTRIBUTE14||CHR(9)||
				C1.ATTRIBUTE15||CHR(9)||
				C1.ATTRIBUTE16||CHR(9)||
				C1.ATTRIBUTE17||CHR(9)||
				C1.ATTRIBUTE18||CHR(9)||
				C1.ATTRIBUTE19||CHR(9)||
				C1.ATTRIBUTE20||CHR(9)||
				C1.CONTEXT||CHR(9)||
				C1.CONTEXT2||CHR(9)||
				C1.INVOICE_DATE||CHR(9)||
				C1.TAX_CODE||CHR(9)||
				C1.INVOICE_IDENTIFIER||CHR(9)||
				C1.INVOICE_AMOUNT||CHR(9)||
				C1.NO1||CHR(9)||
				C1.STAT_AMOUNT||CHR(9)||
				C1.IGNORE_RATE_FLAG||CHR(9)||
				C1.CONTEXT3||CHR(9)||
				C1.USSGL_TRANSACTION_CODE||CHR(9)||
				C1.SUBLEDGER_DOC_SEQUENCE_ID||CHR(9)||
				C1.CONTEXT4||CHR(9)||
				C1.SUBLEDGER_DOC_SEQUENCE_VALUE||CHR(9)||
				C1.REFERENCE_6||CHR(9)||
				C1.REFERENCE_7||CHR(9)||
				C1.GL_SL_LINK_ID||CHR(9)||
				C1.GL_SL_LINK_TABLE||CHR(9)||
				C1.REFERENCE_8||CHR(9)||
				C1.REFERENCE_9||CHR(9)||
				C1.REFERENCE_10||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.JGZZ_RECON_STATUS||CHR(9)||
				C1.JGZZ_RECON_DATE||CHR(9)||
				C1.JGZZ_RECON_ID||CHR(9)||
				C1.JGZZ_RECON_REF||CHR(9)||
				C1.JGZZ_RECON_CONTEXT||CHR(9)||
				C1.TAXABLE_LINE_FLAG||CHR(9)||
				C1.TAX_TYPE_CODE||CHR(9)||
				C1.TAX_CODE_ID||CHR(9)||
				C1.TAX_ROUNDING_RULE_CODE||CHR(9)||
				C1.AMOUNT_INCLUDES_TAX_FLAG||CHR(9)||
				C1.TAX_DOCUMENT_IDENTIFIER||CHR(9)||
				C1.TAX_DOCUMENT_DATE||CHR(9)||
				C1.TAX_CUSTOMER_NAME||CHR(9)||
				C1.TAX_CUSTOMER_REFERENCE||CHR(9)||
				C1.TAX_REGISTRATION_NUMBER||CHR(9)||
				C1.TAX_LINE_FLAG||CHR(9)||
				C1.TAX_GROUP_ID||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.SET_OF_BOOKS_ID)||CHR(9)||
				CAPBREXT_COMMON.GetSegment(C1.CODE_COMBINATION_ID)||CHR(9)||
				CAPBREXT_COMMON.GetDocSeqName(C1.SUBLEDGER_DOC_SEQUENCE_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/